/**
 **	File ......... BaseForm.h
 **	Published ....  2004-07-09
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _BASEFORM_H
#define _BASEFORM_H

#include <libcgi++.h>
#include "Mime.h"
#include <mysql/mysql.h>
#include <libsql++.h>
#include <libibank.h>


class BaseForm : public WebForm
{
public:
	BaseForm(Web *,const std::string& );
	~BaseForm();

	long AddImage(long num,const std::string &filename);
	std::string GetMimeFromFilename(const std::string& );
	std::string GetAccountName(db::Account& );
	bool valid_email(const std::string& );
	void viewtext(const std::string& ,bool in_textarea = false);
	void viewtn(long num);

	void Navigator(long forum = 0,long thread = 0,long message = 0);

private:
	Mime m_mime;
};




#endif // _BASEFORM_H
