/**
 **	File ......... ThreadListForm.cpp
 **	Published ....  2004-07-09
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//#include <stdio.h>

#include "IWeb.h"
#include "ThreadListForm.h"




ThreadListForm::ThreadListForm(Web *w) : BaseForm(w, "ThreadListForm")
{
}


ThreadListForm::~ThreadListForm()
{
}


void ThreadListForm::Process()
{
	IWeb *pWeb = static_cast<IWeb *>(GetWeb());
//	Database& db = pWeb -> GetDatabase();
	char action[200];

	// <input type="submit" name="ThreadListForm" value="action" ...
	if (GetForm() -> getvalue( (char *)GetFormName().c_str(), action, 200) && *action)
	{
		if (!strcmp(action,"view"))
		{
			std::string thread = GetForm() -> getvalue("thread");
			long num = atol(thread.c_str());
			pWeb -> SetThread( num );
			pWeb -> SetPage( 5 );
		}
	}
}


void ThreadListForm::Display(long)
{
	IWeb *pWeb = static_cast<IWeb *>(GetWeb());
	Database& db = pWeb -> GetDatabase();
	Query q(db);
	Query q2(db);
	char sql[1000];

//	printf("<h3>Thread list</h3>");
	Navigator(pWeb -> GetForum());
	if (pWeb -> GetForum())
	{
		printf("</td><td align=center>");
		printf("&nbsp;[&nbsp;<a href=\"%s?page=6\">new topic</a>&nbsp;]",GetCgiName().c_str());
	}
	printf("</td><td align=right>");
//	printf("<div align=right>");
	printf("[ <a href=\"%s?page=2\">settings</a> ",GetCgiName().c_str());
	printf("| <a href=\"%s?logout=1\">logout</a> ",GetCgiName().c_str());
//	printf("]</div>");
	printf("]</td></tr></table>");
	printf("</div>");

	sprintf(sql,"select * from thread where forum=%ld and deleted=0 order by updated desc",pWeb -> GetForum());
	q.get_result(sql);
	printf("<table cellpadding=\"0\" cellspacing=\"0\" class=threadlist width=\"100%%\">");
	printf("<tr>");
	printf("<th class=threadlist>Image</th>");
	printf("<th class=threadlist>Topic</th>");
	printf("<th class=threadlist>Messages</th>");
	printf("<th class=threadlist>Started</th>");
//	printf("<th class=threadlist>Views</th>");
	printf("<th class=threadlist>Last</th>");
	printf("</tr>");
	while (q.fetch_row())
	{
		db::Thread thread(&db, &q);
		db::Account account(db, thread.started_by);
		printf("<tr class=threadlist>");
		// thumbnail
		printf("<td class=threadlist width=\"1%%\">");
		viewtn( thread.image );
		printf("</td>");
		// title
		printf("<td class=threadlist>", thread.title.c_str());
		printf("<a href=\"%s?ThreadListForm=view&thread=%ld\">&nbsp;%s&nbsp;</a></td>",GetCgiName().c_str(),thread.num,thread.title.c_str());
		// message count
		sprintf(sql,"select count(*) from message where thread=%ld and deleted=0",thread.num);
		printf("<td class=threadlist align=right width=\"1%%\">%ld</td>",q2.get_count(sql));
		// started
		printf("<td class=threadlist width=\"1%%\">");
		printf("%s<br>",GetAccountName(account).c_str());
		nbprintf("%s</td>", thread.started.c_str());
		// views
//		printf("<td class=threadlist width=\"1%%\"></td>");
		// last
		{
			db::Account account(db, thread.updated_by);
			printf("<td class=threadlist width=\"1%%\">");
			printf("%s<br>",GetAccountName(account).c_str());
			nbprintf("%s</td>", thread.updated.c_str());
		}
		printf("</tr>");
	}
	printf("</table>");
	q.free_result();
}


