/**
 **	File ......... fiximage.cpp
 **	Published ....  2004-07-09
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <mysql/mysql.h>
#include <libsql++.h>
#include <libibank.h>
#include <libcgi++.h>


int main(int argc,char *argv[])
{
	Database db("localhost","root","","ibank");
	Query q(db);
	Base64 bomb;
	
	q.get_result("select * from image");
	while (q.fetch_row())
	{
		db::Image image(&db, &q);

		printf("%s\n",image.filename.c_str());
		unlink("/tmp/tn.gif");
		unlink("/tmp/geometry");

		while (image.image_tn.size())
		{
			std::vector<std::string>::iterator it = image.image_tn.begin();
			image.image_tn.erase(it);
		}
		bomb.decode_to_file(image.image_data, (char *)image.filename.c_str());
		size_t x = 0;
		size_t y = 0;
		{
			FILE *fil;
			char cmd[1000];
			sprintf(cmd,"%s -verbose -geometry 128 %s /tmp/tn.gif 2>/tmp/geometry",_CONVERT,image.filename.c_str());
			system( cmd );
			if ((fil = fopen("/tmp/geometry", "rt")) != NULL)
			{
				fgets(cmd, 1000, fil);
				while (!feof(fil))
				{
					Parse pa(cmd);
					pa.getword(cmd); // file=>file
					if (!strncmp(cmd,image.filename.c_str(),image.filename.size()))
					{
						pa.getword(); // type
						pa.getword(cmd); // geometry XxY
						{
							Parse pa(cmd,"x=");
							x = pa.getvalue();
							y = pa.getvalue();
							break;
						}
					}
					//
					fgets(cmd, 1000, fil);
				}
				fclose(fil);
			}
		}
		bomb.encode_from_file( "/tmp/tn.gif", image.image_tn);
		image.xsize = x;
		image.ysize = y;
		image.save();
		unlink("/tmp/tn.gif");
		unlink("/tmp/geometry");
	}
	q.free_result();

}


